package com.foobar.model;

import javax.persistence.*;
import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;

@Table(name = "role")
@Entity
public class Role implements Serializable
{
    private static final long serialVersionUID = -8102847004536075987L;
    private Long id;
    private String name;
    private String label;
    private Set<UserRole> userRoles = new HashSet<>(0);

    public Role() {}

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    public Long getId() { return id; }

    public void setId(Long id) { this.id = id; }

    @Column(name = "name")
    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    @OneToMany(fetch = FetchType.LAZY, mappedBy = "role", cascade=CascadeType.ALL, orphanRemoval = true)
    public Set<UserRole> getUserRoles()
    {
        return userRoles;
    }

    public void setUserRoles(Set<UserRole> userRoles)
    {
        this.userRoles = userRoles;
    }
}
