package com.foobar.model;

import javax.persistence.*;
import java.io.Serializable;
import java.util.HashSet;
import java.util.Set;
@Table(name = "applicationuser")
@Entity
@NamedQueries
(
    {
        @NamedQuery(name = "User.findAll",              query = "FROM User u"),
        @NamedQuery(name = "User.findById",             query = "FROM User u WHERE u.id = :id"),
        @NamedQuery(name = "User.findByEmail",          query = "FROM User u WHERE u.email = :email")
    }
)
public class User implements Serializable
{
    private static final long serialVersionUID = -286762400031950218L;
    private Long id;
    private String email;
    private String password;
    private Set<UserRole> userRoles = new HashSet<>(0);

    public User() {}

    public User(String email, String password)
    {
        setEmail(email);
        setPassword(password);
    }

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    public Long getId() { return id; }

    public void setId(Long id) { this.id = id; }

    @Column(name = "email")
    public String getEmail()
    {
        return email;
    }

    public void setEmail(String email)
    {
        this.email = email.toLowerCase();
    }

    @Column(name = "userpassword")
    public String getPassword()
    {
        return password;
    }

     public void setPassword(String password)
    {
        this.password = password;
    }

    @OneToMany(fetch = FetchType.EAGER, mappedBy = "user", orphanRemoval = true)
    public Set<UserRole> getUserRoles()
    {
        return userRoles;
    }

    public void setUserRoles(Set<UserRole> userRoles)
    {
        this.userRoles = userRoles;
    }

}
