package com.foobar.model;

import javax.persistence.*;
import java.io.Serializable;

@Table(name = "user_role")
@Entity
public class UserRole implements Serializable
{
    private static final long serialVersionUID = 5602961967254517328L;
    private Long id;
    private User user;
    private Role role;

    public UserRole() {}

    public UserRole
    (
        User userstamp,
        User user,
        Role role
    )
    {
        setUser(user);
        setRole(role);
    }

    @Id
    @Column(name = "id")
    @GeneratedValue(strategy = GenerationType.AUTO)
    public Long getId() { return id; }

    public void setId(Long id) { this.id = id; }

    @ManyToOne(fetch=FetchType.EAGER, optional=false)
    @JoinColumn(name="userid", referencedColumnName = "id", insertable=false, updatable=false)
    public User getUser()
    {
        return this.user;
    }
 
    public void setUser(User user)
    {
        this.user = user;
    }
 
    @ManyToOne(fetch=FetchType.EAGER, optional=false)
    @JoinColumn(name="roleid", referencedColumnName = "id", insertable=false, updatable=false)
    public Role getRole()
    {
        return this.role;
    }
 
    public void setRole(Role role)
    {
        this.role = role;
    }
}
