package com.foobar.service;

import com.foobar.model.User;

import javax.annotation.security.RolesAllowed;
import javax.ejb.Stateless;
import javax.persistence.*;
import java.util.logging.Logger;

@Stateless
@RolesAllowed("SYSTEM_ADMINISTRATOR")
public class UserService
{
    @SuppressWarnings("NonSerializableFieldInSerializableClass")
    @PersistenceContext EntityManager em;

    public void create(User user)
    {
        try
        {
            em.persist(user);
        }
        catch(Exception ex)
        {
            Logger.getLogger(this.getClass().getName()).severe("Error: " + ex.getMessage());
        }
    }

    public User findByEmail(String email)
    {
        User result = null;
        try
        {
            email = email.toLowerCase();
            result = em.createNamedQuery("User.findByEmail", User.class).setParameter("email", email).getSingleResult();
        }
        catch(Exception ex)
        {
            Logger.getLogger(this.getClass().getName()).severe("Error: " + ex.getMessage());
        }
        return result;
    }

    public User merge(User user)
    {
        User result = null;
        try
        {
            result = em.merge(user);
        }
        catch(Exception ex)
        {
            Logger.getLogger(this.getClass().getName()).severe("Error: " + ex.getMessage());
        }
        return result;
    }
}