package com.foobar.controller.backingbean;

import com.foobar.controller.SessionManager;

import javax.enterprise.inject.Model;
import javax.faces.application.FacesMessage;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.servlet.http.HttpServletRequest;

@Model
public class BackingBean
{
    private static final long serialVersionUID = 6994957210164986005L;
    @Inject protected SessionManager sessionManager;
    private String email;
    private String password;

    public BackingBean() {}

    public boolean isLoggedIn() { return sessionManager.isLoggedIn(); }
    public boolean isLoggedOut() { return sessionManager.isLoggedOut(); }

    public String login()
    {
        String result = null;
        try
        {
            sessionManager.login(email, password);
            result = "loggedIn";
        }
        catch(Exception ex)
        {
            getFacesContext().addMessage(null, new FacesMessage(ex.getMessage()));
            ex.printStackTrace();
            result = "error";
        }
        return result;
    }

    public String logoutSuccess()
    {
        String result = "index";
        try
        {
            sessionManager.logoutSuccess();
        }
        catch(Exception ex)
        {
            getFacesContext().addMessage(null, new FacesMessage(ex.getMessage()));
            ex.printStackTrace();
            result = "error";
        }
        return result;
    }

    public String logoutFailure()
    {
        String result = "error";
        try
        {
            sessionManager.logoutFailure();
            result = "index";
        }
        catch(Exception ex)
        {
            getFacesContext().addMessage(null, new FacesMessage(ex.getMessage()));
            ex.printStackTrace();
        }
        return result;
    }

    public String changePassword()
    {
        String result = null;
        try
        {
            sessionManager.changeUserPassword(password);
            result = "loggedIn";
        }
        catch(Exception ex)
        {
            getFacesContext().addMessage(null, new FacesMessage(ex.getMessage()));
            ex.printStackTrace();
            result = "error";
        }
        return result;
    }

    public String getEmail() { return email; }
    public void setEmail(String email) { this.email = email; }

    public String getPassword() { return password; }
    public void setPassword(String password) { this.password = password; }

    public boolean isPasswordChanged() { return sessionManager.isPasswordChanged(); }

    public FacesContext getFacesContext() { return FacesContext.getCurrentInstance(); }
    public ExternalContext getExternalContext() { return getFacesContext().getExternalContext(); }
    public HttpServletRequest getRequest() { return (HttpServletRequest)getExternalContext().getRequest(); }
    public String getPrincipalName() { return getRequest().getUserPrincipal().getName(); }
}